package edu.washington.cs.knowitall.nlp;

import org.apache.commons.lang.StringUtils;

import edu.washington.cs.knowitall.util.Range;

public class OrdinalNumber {

    private Tokenized source;
    private Range range;
    private int value;

    public OrdinalNumber(Tokenized source, Range range, int value) {
        this.source = source;
        this.range = range;
        this.value = value;
    }

    public int getValue() {
        return value;
    }

    public Range getRange() { 
        return range;
    }

    public Tokenized getSource() {
        return source;
    }

    public Iterable<String> getTokens() {
        return source.getTokens(range);
    }

    public String toString() {
        return StringUtils.join(source.getTokens(range).iterator(), " ");
    }

}
