package edu.washington.cs.knowitall.nlp.extraction;

import edu.washington.cs.knowitall.nlp.ChunkedSentence;
import edu.washington.cs.knowitall.util.Range;

/**
 * A class representing a noun phrase argument of a relation. 
 * @author afader
 *
 */
public class ChunkedArgumentExtraction extends ChunkedExtraction {

    private ChunkedExtraction relation;

    /**
     * Constructs a new <code>NpChunkArgumentExtraction</code> from <code>sent</code> for <code>relation</code>. 
     * @param sent the source sentence.
     * @param range the range of the argument in <code>sent</code>
     * @param relation 
     */
    public ChunkedArgumentExtraction(ChunkedSentence sent, Range range, ChunkedExtraction relation) {
        super(sent, range);
        this.relation = relation;
    }

    /**
     * @return the relation this is an argument to.
     */
    public ChunkedExtraction getRelation() {
        return relation;
    }

}
