package edu.washington.cs.knowitall.util;

public class Pair<S, T> {

    private final S arg1;
    private final T arg2;

    public Pair(S arg1, T arg2) {
        this.arg1 = arg1;
        this.arg2 = arg2;
    }

    public S getArg1() {
        return arg1;
    }

    public T getArg2() {
        return arg2;
    }

    public String toString() {
        return "Pair(" + arg1.toString() + ", " + arg2.toString() + ")";
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((arg1 == null) ? 0 : arg1.hashCode());
        result = prime * result + ((arg2 == null) ? 0 : arg2.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (!(obj instanceof Pair))
            return false;
        Pair<?, ?> other = (Pair<?, ?>) obj;
        if (arg1 == null) {
            if (other.arg1 != null)
                return false;
        } else if (!arg1.equals(other.arg1))
            return false;
        if (arg2 == null) {
            if (other.arg2 != null)
                return false;
        } else if (!arg2.equals(other.arg2))
            return false;
        return true;
    }



}
