package edu.washington.cs.knowitall.util;

import java.util.ArrayList;
import java.util.Collection;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


public class PatternizedMatcher implements PatternMatcher {

    private Pattern pattern;

    public PatternizedMatcher(Pattern pattern) {
        this.pattern = pattern;
    }

    public PatternizedMatcher(String pattern) {
        this.pattern = Pattern.compile(pattern);
    }

    public Collection<Range> getMatches(String patternized) {
        Collection<Range> results = new ArrayList<Range>();
        Matcher matcher = getPattern().matcher(patternized);
        while (matcher.find()) {
            int start = matcher.start();
            int length = matcher.end() - start;
            if (length > 0) {
                Range range = new Range(start, length);
                results.add(range);
            }     
        }
        return results;
    }

    public Pattern getPattern() {
        return pattern;
    }

}
