package edu.washington.cs.knowitall.util;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import edu.washington.cs.knowitall.extractor.ReVerbExtractor;
import edu.washington.cs.knowitall.nlp.ChunkedSentence;
import edu.washington.cs.knowitall.nlp.OpenNlpChunkedSentenceParser;
import edu.washington.cs.knowitall.nlp.extraction.ChunkedBinaryExtraction;

public class PreChunkedReVerbRunner {

    public static void main(String[] args) throws IOException {

        ReVerbExtractor reverb = new ReVerbExtractor();
        OpenNlpChunkedSentenceParser sentParser = new OpenNlpChunkedSentenceParser();
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

        String sentStr;
        int lineNum = 0;
        while ((sentStr = in.readLine()) != null) {
            lineNum++;
            try {
                ChunkedSentence sent = sentParser.parseSentence(sentStr);
                for (ChunkedBinaryExtraction e : reverb.extract(sent)) {
                    String arg1 = e.getArgument1().toString();
                    String arg2 = e.getArgument2().toString();
                    String rel = e.getRelation().toString();
                    System.out.println(lineNum + "\t" + arg1 + "\t" + rel + "\t" + arg2);
                }
            } catch (IllegalArgumentException e) {
                System.err.println("Couldn't parse line " + lineNum + ": " + e.getMessage());
            }
            if (lineNum % 1000000 == 0) System.err.println("Read " + lineNum + " lines");
        }

    }

}
