package test.edu.washington.cs.knowitall.util;

import static org.junit.Assert.*;

import org.apache.commons.lang.StringUtils;
import org.junit.Before;
import org.junit.Test;

import edu.washington.cs.knowitall.util.VerbalRelationNormalizer;

public class VerbalRelationNormalizerTest {
	
	private static VerbalRelationNormalizer normalizer;

	@Before
	public void setUp() throws Exception {
		normalizer = new VerbalRelationNormalizer();
	}
	
	private static void assertNorm(String expectedStr, String tokensStr, String posTagsStr) {
		String[] tokens = tokensStr.split(" ");
		String[] posTags = posTagsStr.split(" ");
		String[] result = normalizer.normalize(tokens, posTags);
		String resultStr = StringUtils.join(result, " ");
		assertEquals(expectedStr, resultStr);
	}

	@Test
	public void testNormalize() {
		assertNorm("attach to", "was attached to", "VBD VBN TO");
		assertNorm("drive", "drove", "VBD");
		assertNorm("be in", "was in", "VBD IN");
		assertNorm("incorporate into", "are incorporated into", "VBP VBN IN");
		assertNorm("take advantage of", "took advantage of", "VBD NN IN");
		assertNorm("be time for", "is the perfect time for", "VBZ DT JJ NN IN");
		assertNorm("be result of", "are the result of", "VBD DT NN IN");
		assertNorm("be liaison between", "will be the liaison between", "MD VB DT NN IN");
		assertNorm("purchase at", "can be purchased at", "MD VB VBN IN");
		assertNorm("delete from", "cannot be deleted from", "MD VB VBN IN");
		assertNorm("be", "can n't be", "MD RB VB");
		assertNorm("require level of", "also requires a high level of", "RB VBZ DT JJ NN IN");
		assertNorm("take kid to", "took my kids to", "VBD PRP$ NNS TO");
		assertNorm("ravage by", "has been ravaged by", "VBZ VBN VBN IN");
		assertNorm("have nothing to do with", "has nothing to do with", "VBZ NN TO VB IN");
	}

}